function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/image-viewer/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import { directive } from "@xmweb-ui/vue-common";
import { isObject } from "@xmweb-ui/vue-renderless/common/type";
var XmTouch = /* @__PURE__ */ function() {
  function XmTouch2(element, xmBinding, type) {
    var that = this;
    that.element = element;
    that.xmBinding = xmBinding;
    that.touchType = type;
    that.xmVueTouches = {
      x: 0,
      y: 0
    };
    that.xmVueMoves = true;
    that.xmVueLeave = true;
    that.xmLongTouch = true;
    that.xmVueCallBack = isObject(xmBinding.value) ? xmBinding.value.fn : xmBinding.value;
    that.element.addEventListener("touchstart", function(e) {
      that.start(e);
    });
    that.element.addEventListener("touchend", function(e) {
      that.end(e);
    });
    that.element.addEventListener("touchmove", function(e) {
      that.move(e);
    });
  }
  var _proto = XmTouch2.prototype;
  _proto.start = function start(e) {
    var _this = this;
    if (e.touches >= 2) {
      return;
    }
    this.xmVueMoves = true;
    this.xmVueLeave = true;
    this.xmLongTouch = true;
    this.xmVueTouches = {
      x: e.changedTouches[0].pageX,
      y: e.changedTouches[0].pageY
    };
    this.time = setTimeout(function() {
      if (_this.xmVueLeave && _this.xmVueMoves) {
        _this.touchType == "longtap" && _this.xmVueCallBack(_this.xmBinding.value, e);
        _this.xmLongTouch = false;
      }
    }, 1e3);
  };
  _proto.end = function end(e) {
    if (e.touches >= 2) {
      return;
    }
    var disX = e.changedTouches[0].pageX - this.xmVueTouches.x;
    var disY = e.changedTouches[0].pageY - this.xmVueTouches.y;
    clearTimeout(this.time);
    if (Math.abs(disX) > 10 || Math.abs(disY) > 100) {
      this.touchType == "swipe" && this.xmVueCallBack(this.xmBinding.value, e);
      if (Math.abs(disX) > Math.abs(disY)) {
        if (disX > 10) {
          this.touchType == "swiperight" && this.xmVueCallBack(this.xmBinding.value, e);
        }
        if (disX < -10) {
          this.touchType == "swipeleft" && this.xmVueCallBack(this.xmBinding.value, e);
        }
      } else {
        if (disY > 10) {
          this.touchType == "swipedown" && this.xmVueCallBack(this.xmBinding.value, e);
        }
        if (disY < -10) {
          this.touchType == "swipeup" && this.xmVueCallBack(this.xmBinding.value, e);
        }
      }
    } else {
      if (this.xmLongTouch && this.xmVueMoves) {
        this.touchType == "tap" && this.xmVueCallBack(this.xmBinding.value, e);
        this.xmVueLeave = false;
      }
    }
  };
  _proto.move = function move() {
    this.xmVueMoves = false;
  };
  return XmTouch2;
}();
var mapDirective = function mapDirective2() {
  var deactives = {};
  var names = ["tap", "swipe", "swipeleft", "swiperight", "swipedown", "swipeup", "longtap"];
  names.forEach(function(name) {
    deactives[name] = directive({
      vTouch: {
        bind: function bind(el, xmBinding) {
          new XmTouch(el, xmBinding, name);
        }
      }
    }).vTouch;
  });
  return deactives;
};
var touchDeactives = mapDirective();

import { IconClose, IconChevronLeft, IconChevronRight, IconZoomOut, IconZoomIn, IconFullscreen, IconMinscreen, IconRepeat, IconRefres, IconDel, IconDownload } from "@xmweb-ui/vue-icon";
import { resolveComponent, resolveDirective, openBlock, createElementBlock, createVNode, Transition, withCtx, createElementVNode, withModifiers, Fragment, normalizeClass, createCommentVNode, createBlock, resolveDynamicComponent, toDisplayString, renderList, normalizeStyle, createTextVNode, withDirectives } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

import "@xmweb-ui/vue-renderless/common/type";
var _sfc_main = defineComponent({
  props: [].concat(props, ["urlList", "zIndex", "onSwitch", "onClose", "showIndex"]),
  emits: ["update:preview-visible", "close", "change", "newImageList"],
  components: {
    IconClose: IconClose(),
    IconChevronLeft: IconChevronLeft(),
    IconChevronRight: IconChevronRight(),
    IconZoomOut: IconZoomOut(),
    IconZoomIn: IconZoomIn(),
    IconFullscreen: IconFullscreen(),
    IconMinscreen: IconMinscreen(),
    IconRepeat: IconRepeat(),
    IconRefres: IconRefres(),
    IconDel: IconDel(),
    IconDownload: IconDownload()
  },
  directives: _extends({}, touchDeactives),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "absolute w-full h-full top-0 left-0 sm:opacity-30 bg-black"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_2 = {
  class: "z-10 absolute inline-flex items-center justify-center box-border select-none left-1/2 bottom-12 -translate-x-1/2 w-60 h-10 px-4 opacity-50 bg-black rounded-[1.375rem] cursor-pointer"
};
var _hoisted_3 = {
  class: "w-full h-full text-justify cursor-default text-2xl flex items-center justify-between fill-color-bg-1"
};
var _hoisted_4 = ["href"];
var _hoisted_5 = {
  key: 1,
  class: "z-10 absolute flex items-center justify-center box-border left-1/2 -translate-x-1/2 px-4 bottom-5"
};
var _hoisted_6 = {
  class: "h-4.5 inline-flex items-center text-color-text-primary"
};
var _hoisted_7 = {
  class: "z-10 flex w-full h-full items-center justify-center"
};
var _hoisted_8 = ["src"];
var _hoisted_9 = {
  class: "w-screen h-screen fixed top-0 left-0 sm:hidden z-50"
};
var _hoisted_10 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "absolute w-full h-full top-0 left-0 bg-black"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_11 = {
  class: "w-screen h-11 text-color-bg-1 absolute leading-[2.75rem] text-center"
};
var _hoisted_12 = {
  href: "javascript:history.go(-1)",
  class: "!text-inherit"
};
var _hoisted_13 = {
  class: "inset-0 fixed"
};
var _hoisted_14 = {
  key: 0,
  class: "absolute flex items-center justify-center box-border left-1/2 -translate-x-1/2 px-4 bottom-12"
};
var _hoisted_15 = {
  class: "h-4.5 inline-flex items-center text-color-bg-1"
};
var _hoisted_16 = {
  ref: "canvasBox",
  class: "w-full h-full"
};
var _hoisted_17 = {
  class: "absolute top-0 left-0 right-0 bottom-0 text-center transition-transform inline-block duration-300"
};
var _hoisted_18 = ["src"];
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_close = resolveComponent("icon-close");
  var _component_icon_chevron_left = resolveComponent("icon-chevron-left");
  var _component_icon_chevron_right = resolveComponent("icon-chevron-right");
  var _component_icon_zoom_out = resolveComponent("icon-zoom-out");
  var _component_icon_zoom_in = resolveComponent("icon-zoom-in");
  var _component_icon_refres = resolveComponent("icon-refres");
  var _component_icon_repeat = resolveComponent("icon-repeat");
  var _component_icon_del = resolveComponent("icon-del");
  var _component_icon_download = resolveComponent("icon-download");
  var _component_IconChevronLeft = resolveComponent("IconChevronLeft");
  var _directive_swipeleft = resolveDirective("swipeleft");
  var _directive_swiperight = resolveDirective("swiperight");
  return openBlock(), createElementBlock("div", null, [createVNode(Transition, {
    name: "viewer-fade"
  }, {
    default: withCtx(function() {
      return [createElementVNode(
        "div",
        {
          class: "fixed inset-0 hidden sm:block z-10",
          onMousewheel: _cache[11] || (_cache[11] = withModifiers(function() {
          }, ["prevent"]))
        },
        [_hoisted_1, createElementVNode("span", {
          class: "flex absolute items-center justify-center rounded-full box-border select-none top-20 right-20 bottom-10 text-xl cursor-pointer w-8 h-8 hover:bg-color-text-primary active:bg-color-border fill-color-bg-1 bg-color-border",
          onClick: _cache[0] || (_cache[0] = function() {
            return _ctx.hide && _ctx.hide.apply(_ctx, arguments);
          })
        }, [createVNode(_component_icon_close, {
          class: "fill-color-bg-1 cursor-pointer"
        })]), !_ctx.state.isSingle ? (openBlock(), createElementBlock(
          Fragment,
          {
            key: 0
          },
          [createElementVNode(
            "span",
            {
              class: normalizeClass(["absolute flex items-center justify-center rounded-full box-border select-none top-1/2 w-8 h-8 bg-color-border -translate-y-1/2 left-20 hover:bg-color-text-primary active:bg-color-border fill-color-bg-1 cursor-pointer", {
                "is-disabled": !_ctx.state.infinite && _ctx.state.isFirst
              }]),
              onClick: _cache[1] || (_cache[1] = function() {
                return _ctx.prev && _ctx.prev.apply(_ctx, arguments);
              })
            },
            [createVNode(_component_icon_chevron_left)],
            2
            /* CLASS */
          ), createElementVNode(
            "span",
            {
              class: normalizeClass(["absolute flex items-center justify-center rounded-full box-border select-none top-1/2 w-8 h-8 -translate-y-1/2 right-20 indent-0.5 hover:bg-color-text-primary active:bg-color-border fill-color-bg-1 bg-color-border cursor-pointer", {
                "is-disabled": !_ctx.state.infinite && _ctx.state.isLast
              }]),
              onClick: _cache[2] || (_cache[2] = function() {
                return _ctx.next && _ctx.next.apply(_ctx, arguments);
              })
            },
            [createVNode(_component_icon_chevron_right)],
            2
            /* CLASS */
          )],
          64
          /* STABLE_FRAGMENT */
        )) : createCommentVNode("v-if", true), createElementVNode("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [(openBlock(), createBlock(resolveDynamicComponent(_ctx.state.mode.icon), {
          class: "cursor-pointer",
          onClick: _ctx.toggleMode
        }, null, 8, ["onClick"])), createVNode(_component_icon_zoom_out, {
          class: "cursor-pointer",
          onClick: _cache[3] || (_cache[3] = function($event) {
            return _ctx.handleActions("zoomOut");
          })
        }), createVNode(_component_icon_zoom_in, {
          class: "cursor-pointer",
          onClick: _cache[4] || (_cache[4] = function($event) {
            return _ctx.handleActions("zoomIn");
          })
        }), createVNode(_component_icon_refres, {
          class: "cursor-pointer",
          onClick: _cache[5] || (_cache[5] = function($event) {
            return _ctx.handleActions("clocelise");
          })
        }), createVNode(_component_icon_repeat, {
          class: "cursor-pointer",
          onClick: _cache[6] || (_cache[6] = function($event) {
            return _ctx.handleActions("anticlocelise");
          })
        }), createVNode(_component_icon_del, {
          class: "cursor-pointer",
          onClick: _cache[7] || (_cache[7] = function($event) {
            return _ctx.handleActions("delImage");
          })
        }), createElementVNode("a", {
          href: "" + _ctx.state.currentImg,
          target: "_blank",
          download: "",
          class: "cursor-pointer inline-flex fill-color-bg-1"
        }, [createVNode(_component_icon_download)], 8, _hoisted_4)])]), _ctx.showIndex ? (openBlock(), createElementBlock("div", _hoisted_5, [createElementVNode(
          "span",
          _hoisted_6,
          toDisplayString(_ctx.state.index + 1 + "/" + _ctx.urlList.length),
          1
          /* TEXT */
        )])) : createCommentVNode("v-if", true), createElementVNode("div", _hoisted_7, [(openBlock(true), createElementBlock(
          Fragment,
          null,
          renderList(_ctx.urlList, function(url, i) {
            return openBlock(), createElementBlock(
              Fragment,
              null,
              [i === _ctx.state.index ? (openBlock(), createElementBlock("img", {
                ref_for: true,
                ref: "img_" + i,
                key: url,
                src: _ctx.state.currentImg,
                style: normalizeStyle(_ctx.state.imgStyle),
                onError: _cache[8] || (_cache[8] = function() {
                  return _ctx.handleImgError && _ctx.handleImgError.apply(_ctx, arguments);
                }),
                onMousedown: _cache[9] || (_cache[9] = function() {
                  return _ctx.handleMouseDown && _ctx.handleMouseDown.apply(_ctx, arguments);
                }),
                onLoad: _cache[10] || (_cache[10] = function() {
                  return _ctx.handleImgLoad && _ctx.handleImgLoad.apply(_ctx, arguments);
                })
              }, null, 44, _hoisted_8)) : createCommentVNode("v-if", true)],
              64
              /* STABLE_FRAGMENT */
            );
          }),
          256
          /* UNKEYED_FRAGMENT */
        ))])],
        32
        /* HYDRATE_EVENTS */
      )];
    }),
    _: 1
    /* STABLE */
  }), createVNode(Transition, {
    name: "viewer-fade"
  }, {
    default: withCtx(function() {
      return [createElementVNode("div", _hoisted_9, [_hoisted_10, createElementVNode("div", _hoisted_11, [createElementVNode("a", _hoisted_12, [createVNode(_component_IconChevronLeft, {
        class: "fill-color-bg-1 absolute w-4 h-4 top-3.5 left-3"
      }), createTextVNode("图片预览")])]), withDirectives((openBlock(), createElementBlock("div", _hoisted_13, [_ctx.showIndex ? (openBlock(), createElementBlock("div", _hoisted_14, [createElementVNode(
        "span",
        _hoisted_15,
        toDisplayString(_ctx.state.index + 1 + "/" + _ctx.urlList.length),
        1
        /* TEXT */
      )])) : createCommentVNode("v-if", true), createElementVNode(
        "div",
        _hoisted_16,
        [createElementVNode(
          "div",
          {
            class: "h-full flex items-center justify-center w-[69.375rem]",
            style: normalizeStyle({
              "width": _ctx.state.iamgeAllWidth + "px",
              "transition-duration": _ctx.state.imageTransition + "ms",
              transform: "translateX(" + _ctx.state.imageTransformSize + "px)"
            })
          },
          [createElementVNode("template", null, [(openBlock(true), createElementBlock(
            Fragment,
            null,
            renderList(_ctx.urlList, function(url, i) {
              return openBlock(), createElementBlock(
                "div",
                {
                  class: "relative shrink h-full w-[23.125rem]",
                  ref_for: true,
                  ref: "viewerItem",
                  key: i,
                  style: normalizeStyle(Object.assign({
                    width: _ctx.state.imageItemWidth + "px"
                  }, i === _ctx.state.index ? _ctx.state.imgStyle : ""))
                },
                [createElementVNode("div", _hoisted_17, [i === _ctx.state.index ? (openBlock(), createElementBlock("img", {
                  key: url,
                  class: normalizeClass(["block w-full h-full object-contain", {
                    "object-fill": _ctx.state.fullScreen
                  }]),
                  ref_for: true,
                  ref: "img_" + i,
                  src: _ctx.state.currentImg,
                  style: normalizeStyle(_ctx.state.imgStyle),
                  onMousedown: _cache[12] || (_cache[12] = function() {
                    return _ctx.handleMouseDown && _ctx.handleMouseDown.apply(_ctx, arguments);
                  }),
                  onError: _cache[13] || (_cache[13] = function() {
                    return _ctx.handleImgError && _ctx.handleImgError.apply(_ctx, arguments);
                  }),
                  onLoad: _cache[14] || (_cache[14] = function() {
                    return _ctx.handleImgLoad && _ctx.handleImgLoad.apply(_ctx, arguments);
                  }),
                  onTouchstart: _cache[15] || (_cache[15] = function() {
                    return _ctx.touchstart && _ctx.touchstart.apply(_ctx, arguments);
                  }),
                  onTouchmove: _cache[16] || (_cache[16] = function() {
                    return _ctx.touchmove && _ctx.touchmove.apply(_ctx, arguments);
                  }),
                  onTouchend: _cache[17] || (_cache[17] = function() {
                    return _ctx.touchend && _ctx.touchend.apply(_ctx, arguments);
                  })
                }, null, 46, _hoisted_18)) : createCommentVNode("v-if", true)])],
                4
                /* STYLE */
              );
            }),
            128
            /* KEYED_FRAGMENT */
          ))])],
          4
          /* STYLE */
        )],
        512
        /* NEED_PATCH */
      )])), [[_directive_swipeleft, _ctx.swipeLeft], [_directive_swiperight, _ctx.swipeRight]])])];
    }),
    _: 1
    /* STABLE */
  })]);
}
var mobileFirst = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  mobileFirst as default
};
